*** crypto.erl	2007-05-20 02:19:32.000000000 -0400
--- ../crypto.erl	2007-05-20 02:38:31.000000000 -0400
***************
*** 21,30 ****
--- 21,31 ----
  -module(crypto).
  
  -export([start/0, stop/0, info/0]).
  -export([md5/1, md5_init/0, md5_update/2, md5_final/1]).
  -export([sha/1, sha_init/0, sha_update/2, sha_final/1]).
+ -export([sha256/1, sha256_init/0, sha256_update/2, sha256_final/1]).
  -export([md5_mac/2, md5_mac_96/2, sha_mac/2, sha_mac_96/2]).
  -export([des_cbc_encrypt/3, des_cbc_decrypt/3, des_cbc_ivec/1]).
  -export([des3_cbc_encrypt/5, des3_cbc_decrypt/5]).
  -export([des_ede3_cbc_encrypt/5, des_ede3_cbc_decrypt/5]).
  -export([aes_cfb_128_encrypt/3, aes_cfb_128_decrypt/3]).
***************
*** 63,80 ****
--- 64,90 ----
  -define(DSS_VERIFY,	 22).
  -define(RSA_VERIFY,	 23).
  -define(AES_CBC_128_ENCRYPT, 24).
  -define(AES_CBC_128_DECRYPT, 25).
  
+ -define(SHA256,		 26).
+ -define(SHA256_INIT,	 27).
+ -define(SHA256_UPDATE,	 28).
+ -define(SHA256_FINAL,	 29).
+ 
  -define(FUNC_LIST, [md5,
  		    md5_init,
  		    md5_update,
  		    md5_final,
  		    sha,
  		    sha_init,
  		    sha_update,
  		    sha_final,
+ 		    sha256,
+ 		    sha256_init,
+ 		    sha256_update,
+ 		    sha256_final,
  		    md5_mac,
  		    md5_mac_96,
  		    sha_mac,
  		    sha_mac_96,
  		    des_cbc_encrypt,
***************
*** 136,145 ****
--- 146,167 ----
      control(?SHA_UPDATE, [Context, Data]).
  
  sha_final(Context) ->
      control(?SHA_FINAL, Context).
  
+ sha256(Data) ->
+     control(?SHA256, Data).
+ 
+ sha256_init() ->
+     control(?SHA256_INIT, []).
+ 
+ sha256_update(Context, Data) ->
+     control(?SHA256_UPDATE, [Context, Data]).
+ 
+ sha256_final(Context) ->
+     control(?SHA256_FINAL, Context).
+ 
  %%
  %%  MESSAGE AUTHENTICATION CODES
  %%
  
  %%
